(function(_window) {
     var undefined = 'undefined';
    if(typeof _window==undefined) return;
     win = _window;
     win.undefined = undefined;

    if(typeof(win.H5Events) == 'function'){
        console.log('H5Events 已存在');
        return;
    }
    console.log('开始注入H5Events');
    var _H5Events = function() {};
    _H5Events.prototype.constructor = _H5Events;
    _H5Events.fn = _H5Events.prototype;
    _H5Events.fn.init = function(id) {
        this.H5Events = 1.0;
        this.clientID = id;
        return this;
    }
    _H5Events.fn.on = function() {

        var that = this;
        if(typeof(win.XSJBridge_H5EventsCapture)==undefined) return -1;
        var callback = win.XSJBridge_H5EventsCapture.waitForCallback;
        if (typeof callback != 'function') return -2;
        var registerEvents = win.XSJBridge_H5EventsCapture.getRegisterEvents();
        var eventList = null;
        if(Array.isArray(registerEvents)){
            eventList = registerEvents;
        }else{
            eventList = JSON.parse(registerEvents);
        }
        if(!Array.isArray(eventList)) return -3;
        if (typeof(win.document._H5Events) != 'object') {
            win.document._H5Events = {};
        }
        if(Object.isFrozen(win.document._H5Events)) return -4;          //不在接受注册
        Array.prototype.forEach.call(eventList,function(event){
            if(typeof(win.document._H5Events[event])!='function'){      //说明该事件已经注册了
                var cb = win.document._H5Events[event];
                 win.document.removeEventListener(event,cb,true);
            }
             win.document._H5Events[event] = callback;
             console.log('开始监听:'+event+'事件');
             that.registerEventsListener(event);

        });
        return that.clientID;
    };
    _H5Events.fn.registerEventsListener = function(eventName){
         var that = this;
         window.document.addEventListener(eventName,
                function(e) { 
                    var data = that._handleEvent(e,eventName);
                    if(typeof(win.XSJBridge_H5EventsCapture)==undefined) return false;
                    var fn = win.document._H5Events[eventName];
                    fn.call(win.XSJBridge_H5EventsCapture,JSON.stringify(data));
                    return false;  //不处理该事件
                },true);  //早传递阶段拦截
    }
    _H5Events.fn.getCurrentStyle = function(dom,cssStyleName){
          return win.getComputedStyle(dom , null)['top']
    }
    _H5Events.fn._handleEvent = function(e,eventName) {
        var target = e.srcElement || e.target;
        var that = this;

        var eventData = {
            top:that.getCurrentStyle(target,'top'),
            timeStamp: e.timeStamp,
            eventName: eventName,
            tagName: target.tagName || target.nodeName,
            id:  target.getAttribute('id'),
            offsetTop: target.offsetTop || target.pageYOffset ,
            offsetLeft: target.offsetLeft || target.pageXOffset,
            scrollTop: target.scrollTop,
            scrollLeft: target.scrollLeft,
            scrollHeight: target.scrollHeight,
            scrollWidth: target.scrollWidth,
            height: target.clientHeight,
            width: target.clientWidth,
            isEditable: target.isContentEditable,
            isHidden: target.hidden,
            clientID:that.clientID,
            url:target.baseURI,
        };

        if(eventName=='touchstart' || eventName=='touchend' || eventName=='touchmove'){
            var pathSet = (e.composedPath() || e.path).reverse();
            var touches = e.touches || [];
            if(touches.length>0){
                var x = touches[0].pageX;
                var y = touches[0].pageY;
                eventData['pageX'] = x;
                eventData['pageY'] = y;
            }

            for(var i=0;i<pathSet.length;i++){
                var dom = pathSet[i];
                if(dom.scrollHeight>dom.clientHeight){
                    eventData['tagName'] = dom.tagName;
                    eventData['id']   = dom.id;
                    eventData['scrollTop']   = dom.scrollTop;
                    eventData['scrollLeft']   = dom.scrollLeft;
                    eventData['scrollHeight']   = dom.scrollHeight;
                    eventData['scrollWidth']   = dom.scrollWidth;
                    eventData['scrollHeight']   = dom.scrollHeight;
                    eventData['height']   = dom.clientHeight;
                    eventData['width']   = dom.clientWidth;
                    eventData['offsetTop'] =  target.offsetTop;
                    eventData['offsetLeft'] =  target.offsetLeft;
                    eventData['isEditable']   = dom.isContentEditable;
                    eventData['isHidden']   = dom.hidden;
                    break;
                }
            }
        }
        return eventData;
    }
    win.H5Events = function(id) {
        return new _H5Events().init(id);
    }
    var $_loadEvents = function(){
            if(typeof(win.XSJBridge_H5EventsCapture)==undefined) return -1;
            var clientID = win.XSJBridge_H5EventsCapture.getClientID();
            if(typeof(win.document.clientIDS)==undefined){
                    win.document.clientIDS = [];
            }
            if(win.document.clientIDS.indexOf(clientID)!=-1) {
                console.log('H5EventsCapture已存在');
                return;
            }
            win.document.clientIDS.push(clientID);
            console.log('启动H5Events....'+clientID);
            H5Events(clientID).on();
    }
    if(win.document.readyState!='complete'){
        win.document.addEventListener('DOMContentLoaded',$_loadEvents,false);
    }else{
        $_loadEvents();
    }
    console.log('完成注入H5Events');
})(window);